Namespace("Data");

Data.ModelFactory = (function() {
	
	/* START PRIVATE PROPERTIES */
	
	CreateStationsList = function(data) {

		var result = [];
		
		for(var i = 0; i < data.length; i++) {
			result.push(CreateStationModel(data[i]));
		}
		
		return result;
	}
	
	CreateCategoriesList = function(data) {

		var result = [];
		
		for(var i = 0; i < data.length; i++) {
			result.push(CreateCategoryModel(data[i]));
		}
		
		return result;
	}
	
	CreateStreamsList = function(data) {

		var result = [];
		
		for(var i = 0; i < data.length; i++) {
			result.push(CreateStreamModel(data[i]));
		}
		
		return result;
	}
	
	CreateStationModel = function(data) {
		
		return {
			"ID" : data.id,
			"Title" : data.name,
			"Description" : data.description,
			"ImageUrl" : data.image_url.replace("2.jpg", "3.jpg"),
			"Subtitle" : data.rating
		}
	}
	
	CreateCategoryModel = function(data) {
		
		return {
			"ID" : data.id,
			"Title" : data.name,
			"Description" : data.description,
			"ImageUrl" : data.image_url.replace("2.jpg", "3.jpg"),
			"Subtitle" : data.rating
		}
	}
	
	CreateStreamModel = function(data) {
		
		return {
			"ID" : data.id,
			"Title" : data.name,
			"Description" : data.description,
			"ImageUrl" : data.image_url.replace("2.jpg", "3.jpg"),
			"Subtitle" : data.rating
		}
	}
	
	/* END METHODS */
	
	/* RETURN INSTANCE OBJECT -- WITH PUBLIC MEMBERS */
	return {
		CreateStationsList : CreateStationsList,
		CreateStationModel : CreateStationModel,
		CreateCategoriesList : CreateCategoriesList,
		CreateCategoryModel : CreateCategoryModel,
		CreateStreamsList : CreateStreamsList,
		CreateStreamModel : CreateStreamModel,
	};
	
})();