Array.prototype.removeAt = function (iIndex){
    var vItem = this[iIndex];
    if (vItem) {
        this.splice(iIndex, 1);
    }
    return vItem;
};

Namespace("FavoritesManager");

FavoritesManager = (function() {

	/* START METHODS */

	var _events = {};
	
	function addListener(eventName, callback) {
	    var events = _events,
	        callbacks = events[eventName] = events[eventName] || [];
	    
	    if(callbacks.indexOf(callback) == -1)
	    {
	    	callbacks.push(callback);
	    }
	}
	
	 function raiseEvent(eventName, args) {
		var events = _events;
	    var callbacks = events[eventName] = events[eventName] || [];
	    for (var i = 0, l = callbacks.length; i < l; i++) {
	        callbacks[i](eventName, args);
	    }
	}
	
	function ToggleFavorite() {		
		var playing_station_id = PlayerModule.GetCurrentStation();
		
		//check to see if we already have the favorites on our list//
		var exists = FavoriteExists();
		var mode = "add";
		
		if (exists){
			mode = "remove";
		}
		
		Data.DataServiceMain.UpdatePreset(playing_station_id,mode, function(responseData){
			
		//if the data is not null
		//hide the activity indicator clear the status text
		if (responseData != null){

				currentFavList = JSON.parse(Manager.LocalStorageManager.getItem("FAVORITES_LIST"));

	            if(mode == "add")
	            {
	            	if(currentFavList.indexOf(playing_station_id) == -1)
	            	{
	            		currentFavList.push(playing_station_id);
	            	}
	            }
	            else
	            {
	            	var itemIdx = currentFavList.indexOf(playing_station_id);
	            	if(itemIdx != -1)
	            	{
	            		currentFavList.removeAt(itemIdx);
	            	}
	            }

	            PlayerModule.UpdateFavoriteState();
	        }
	        else{
	            
	        }
		});
	
	}

	function UpdateFavoriteState()
	{
		var playing_station_id = Manager.LocalStorageManager.getItem("CURRENT_PLAYING_STATION_ID");

		raiseEvent("favoriteStateUpdated", {state : FavoriteExists});

	}
	
	function FavoriteExists() {
		return PlayerModule.IsPreset();
	}
	
	/* RETURN INSTANCE OBJECT -- WITH PUBLIC METHODS */
	return {
		ToggleFavorite : ToggleFavorite,
		UpdateFavoriteState : UpdateFavoriteState,
		FavoriteExists : FavoriteExists
	};

})();