/////////////////
//* handles local storage. get, set and remove
Namespace("Manager");

Manager.LocalStorageManager = (function() {
	/* START PUBLIC METHODS */
	setItem = function(key, value){
		try {
			// JSON it so we can save objects instead of just strings
			localStorage.setItem(key, JSON.stringify(value)); //saves to the database, "key", "value"
			return "success";
		} catch (e) {
		 	 if (e == QUOTA_EXCEEDED_ERR) {
		 	 	 alert('Quota exceeded!'); //data wasn't successfully saved due to quota exceed so throw an error
		 	 	 return null;
		 	 }
		}
	
	};
	
	getItem = function(key){
		try {
			return JSON.parse(localStorage.getItem(key));
		} catch (e) {
			  alert(e); //show any errors
			return null;
		}
	};
		
	removeItem = function(key){
		try {
			localStorage.removeItem(key); //removes it from the database, "key"
		} catch (e) {
		 	  alert(e); //show any errors
		}
	};
	
	/* END METHODS */
	
	/* RETURN INSTANCE OBJECT -- WITH PUBLIC MEMBERS */
	return {
		setItem : setItem,
		getItem : getItem,
		removeItem : removeItem
	};
})();


