/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

Namespace("Views");

Views.BrowseListPage = (function() {


    const BASE_URL = "http://opml.radiotime.com/";
            const FORMATS = "&formats=mp3,aac";
            const PARTNER_ID = "&partnerId=GdTO4j7I";
            const BROWSE = BASE_URL + "Browse.ashx?";
            const NEWS = "id=c57922&";

    var nowPlayingId = {};
    var PageRoot;
    var ListRoot;
    var isStartPage;
    var refreshUrl;

    function Init(url) {
        refreshUrl = url;
        if (url == BROWSE + FORMATS + PARTNER_ID) {
            PageRoot = document.getElementById("screen-browse"); // Root element of this screen
            isStartPage = true;
        }
        else {
            PageRoot = document.getElementById("screen-stationlist"); // Root element of this screen
            isStartPage = false;
        }
        Views.BrowseListPage.LoadData(url);
		UpdateMiniPlayerContent();
        PlayerModule.addListener("playerStateUpdated", UpdateMiniPlayerContent);
    }



	function UpdateMiniPlayerContent()
    {
        $(PageRoot).find("#tunein-playerbar").html("");
        $(PageRoot).find("#tunein-playerbar").append(PlayerModule.GetMiniPlayerDiv());
    }



    function LoadData(url) {

        Data.DataServiceMain.GetBrowseCategories(url, function(data) {
            if (data != null) {
                ActivityManager.HideIndicator();
                var browseItems = [];
                var i = 0;
                var item;
                var areStations = false;
                var newsInserted = false;
                var recentsInserted = false;
                var name;
                var browseList;
                var items = $(data).find("outline");
                var i = 0;
                while((item = items[i]) != undefined) {
                    name = $(item).attr("text");
                    if (name.toLowerCase()== "my favorites") {
                        items.splice(i, 1);
                        i > 0 ? i = i-1 : i = 0;
                    } else {
                        var stationLogo;
                        //set custom logos for Start Page only
                        if (isStartPage) {
                            //startpage icons are named after each category,no spaces, lowercase
                            var logoname = (name).replace(/\s/g, "").toLowerCase();
                            stationLogo = "images/icons/categories/" + logoname + ".png";
                        } else if (SettingsManager.Instance.GetLogosPref()) {
                            stationLogo = $(item).attr("image");
                        }
                        var browseUrl = $(item).attr("URL")
                        //construct a general browse item
                        var browseItem = {Title: name, ImageUrl: stationLogo, Description: $(item).attr("subtext")};
                        var itemType = $(item).attr('type');
                        //custom markup for subcategory
                        browseItem.attr = {};
                        if (typeof(stationLogo) == 'undefined' && typeof(itemType) != 'undefined') {
                            browseItem.attr ["data-tunein-type"] = "no_image_item";
                            //custom mark-up for header    
                        } else if (typeof(itemType) == 'undefined') {
                            browseItem.attr ["data-bb-type"] = "header";
                        }
                        //setting onclick event for station
                        if (itemType === 'audio' && $(item).attr("text").toLowerCase().indexOf("not supported") == -1) {
                            var guide_id = $(item).attr('guide_id');
                            browseItem.attr ["onclick"] = "bb.pushScreen('views/player.html', 'playerView',{stationId : '" + guide_id + "' });";
                        } else if (itemType === 'link'){  // type is link, means its a category, header is undefined  
                            browseItem.attr ["onclick"] = "bb.pushScreen('views/stationlist.html', 'stationlist', {url: '" + browseUrl + "' });";
                        }
                        browseItems[i] = browseItem;
                        i++;
                    }
                }

                //insert extra items to Start Page
                if (isStartPage) {
                    browseItems = createAndAddExtraItems(browseItems);
                }
                //apply bbui markup
                list = BBUI_Helper.CreateList(browseItems);
                if (isStartPage) {
                    ListRoot = document.getElementById("BrowseList").appendChild(list);
                } else {
                    ListRoot = document.getElementById("StationList").appendChild(list);
                }
                bb.doLoad(PageRoot);

            } else {
                ActivityManager.ShowFeedback("Service unavailable. Please try again later.");
            }
        });
    }

    function refresh() {
        ListRoot.innerHTML="";
        ActivityManager.ShowIndicator();
        Init(refreshUrl);
    }

    function createAndAddExtraItems(toItems) {
        var newItems = [];
        var logoname = ("Recents").replace(/\s/g, "").toLowerCase();
        var recentsCategory = {Title: "Recents", ImageUrl: "images/icons/categories/recents.png", Description: ""};
        recentsCategory.attr = {};
        recentsCategory.attr ["onclick"] = "bb.pushScreen('views/recents.html', 'recents');";
        recentsCategory.index = 1;
        newItems.push(recentsCategory);
        var newsCategory = {Title: "News", ImageUrl: "images/icons/categories/news.png", Description: ""};
        newsCategory.attr = {};
        newsCategory.attr ["onclick"] = "bb.pushScreen('views/stationlist.html', 'stationlist', {url: '" + BROWSE + NEWS + PARTNER_ID + "' });";
        newsCategory.index = 5;
        newItems.push(newsCategory);
        insertExtraItems(newItems, toItems);
        return toItems;
    }

    function insertExtraItems(newItems, toItems) {
        for (var i = 0; i < newItems.length; i++) {
            insertItem(newItems[i].index, newItems[i], toItems);
        }
        return toItems;
    }

    function insertItem(index, itemToInsert, toItems) {
        //insert item to index removing 0 elements
        toItems.splice(index, 0, itemToInsert);
        toItems.join();
        return toItems;
    }


    return {
        Init: Init,
        LoadData: LoadData,
        refresh: refresh
    }
})();

