Namespace("Views");

Views.LoginPage = (function(){
	
	var PageRoot;

	function Init() {
		PageRoot = document.getElementById("screen-tunein-login"); // Root element of this screen

		ActivityManager.HideIndicator();
	}

	function DoLogin()
	{
		var tuneInLoginAPI=Utils.Constants.TUNE_IN_API+"Account.ashx";
		var username = document.getElementById('tuneinlogin-username').value;
		var pwd = document.getElementById('tuneinlogin-password').value;
		var params = "c=auth&partnerId="+Utils.Constants.PARTNER_ID+"&username="+encodeURIComponent(username)+"&password="+encodeURIComponent(pwd);

		if (username=="" || pwd==""){
			ActivityManager.ShowFeedback("Please enter a valid Username and Password.");
		}
		else 
		{
			//clear any feedback we might have
			ActivityManager.ShowIndicator();
			ActivityManager.ShowFeedback("");
			Data.DataServiceMain.DoRequestToUrl(tuneInLoginAPI + "?" + params, function(responseData){

				if(responseData != null)
				{
					//store their id for later use (ie. getting favorites)
					var userid = responseData.body[0].UserName;
					SettingsManager.Instance.SetUserID(username);

					Data.DataServiceMain.JoinUserToDevice(userid, pwd, function(data){
						console.log("JOIN RESULT:", data)
					});
					
				    bb.pushScreen('views/favorites.html', 'favoritesView');
				}
				else
				{
				    ActivityManager.ShowFeedback("Your username or password was not recognized. Please try again.");
				}
				
				ActivityManager.HideIndicator();
			});
		}
	}

	function DoLogout()
	{
		SettingsManager.Instance.SetUserID("");

		Manager.LocalStorageManager.setItem("FAVORITES_LIST", JSON.stringify([]));

		SettingsManager.Instance.ResetDeviceID();

		bb.pushScreen('views/browse.html', 'browse');
	}

	function HandlePasswordKeyPress (event) {
		if(event.keyCode == 13) // If ENTER
		{
			Views.LoginPage.DoLogin();
		}
	}

	return {
		Init: Init,
		DoLogin : DoLogin,
		DoLogout : DoLogout,
		HandlePasswordKeyPress : HandlePasswordKeyPress
	}
	
}());

Views.AccountPage = (function(){
	
	var PageRoot;

	function Init() {
		PageRoot = document.getElementById("screen-account"); // Root element of this screen

		if (Utils.GeneralUtils.IsNullOrEmpty(SettingsManager.Instance.GetUserID()))
		{
			$(PageRoot).find("#tunein-login-panel").show();
			$(PageRoot).find("#tunein-logout-panel").hide();
		}
		else
		{
			$(PageRoot).find("#tunein-login-panel").hide();
			$(PageRoot).find("#tunein-logout-panel").show();

			$(PageRoot).find("#tunein-logout-panel #logged-in-message").html("Logged in as " + SettingsManager.Instance.GetUserID());
		}

		UpdateMiniPlayerContent();
		PlayerModule.addListener("playerStateUpdated", UpdateMiniPlayerContent);
	}

	function UpdateMiniPlayerContent(){
        $(PageRoot).find("#tunein-playerbar").html("");
        $(PageRoot).find("#tunein-playerbar").append(PlayerModule.GetMiniPlayerDiv());
    }

	return {
		Init: Init
	}
	
}());
