/*
 * This script is for the search screen
 */

Namespace("Views");
	
Views.RelatedPage = (function(){
	var PageRoot;
        
	function Init(url) {
		//called when the users clicks the 'back' button
		var currentStation = Manager.LocalStorageManager.getItem('CURRENT_PLAYING_STATION_ID');
		
		//if there is no current station, let's just default to one
		if (currentStation==""){
			ActivityManager.ShowFeedback("Service unavailable. Please try again later.");
		}
                if(!Utils.GeneralUtils.IsNullOrEmpty(url)) {
                    PageRoot = document.getElementById("screen-related-subcategory"); // Root element of this screen
                    UpdateMiniPlayerContent();
                    PlayerModule.addListener("playerStateUpdated", UpdateMiniPlayerContent);
                    Views.RelatedPage.doShowRelated(currentStation,url);
                } else {
                    PageRoot = document.getElementById("screen-player-related"); 
                    Views.RelatedPage.doShowRelated(currentStation,"");
                }
                 
	}
        
        function UpdateMiniPlayerContent() {
            $(PageRoot).find("#tunein-playerbar").html("");
            $(PageRoot).find("#tunein-playerbar").append(PlayerModule.GetMiniPlayerDiv());
        }
	
	function doShowRelated(currentStation,url) {

	//clear any feedback we might have
	ActivityManager.ShowFeedback("");

	var requestUrl=Utils.Constants.TUNE_IN_API+"Browse.ashx";
	var params = "partnerId="+Utils.Constants.PARTNER_ID+"&id="+currentStation;

	//if there is a url then we are reloading the related page, but for genres//
	if (url == ""){
            requestUrl = requestUrl + "?" + params;
	} else {
            requestUrl = url;
        }
	
	

	//alert(currentStation);
	
	Data.DataServiceMain.DoRequestToUrl(requestUrl,function(responseData){

	var url,text,audioType,guide_id,playing_image,bitrate ="";
			//if the status is 200 then all is good, lets proceed
			
			ActivityManager.HideIndicator();
			ActivityManager.ClearFeedback();
			
			if (responseData != null)
			{
				//clear our list of any old results
				document.getElementById('relatedDataList').innerHTML="";
				
				// Create our list item
				for (var idx in responseData.body){
					var category = responseData.body[idx];
					
					//show the category labels
					var dataList = document.getElementById('relatedDataList');
					
					var listItem = CreateListItem(category);
					
					dataList.appendChild(listItem);
					
					if(category.children != null) {
						for(var i = 0; i < category.children.length; i++)
						{
							var item = category.children[i];
							var listItem = CreateListItem(item);
							dataList.appendItem(listItem);
						}
					}
				}
				ActivityManager.ShowFeedback("");
			}
			else
			{
				ActivityManager.HideIndicator();
			    ActivityManager.ShowFeedback("Search unavailable. Please try again later.");
			}
		});
		
		ActivityManager.ShowFeedback("Loading...");
	}
	
	function CreateListItem(item) {
		var listItem = document.createElement('div');
		
		var itemType = $(item).attr('type');
		
		if(itemType != null && itemType == "link")
		{
			listItem.setAttribute('data-bb-type', 'item');
			listItem.setAttribute('data-bb-title', $(item).attr('text'));
			listItem.setAttribute('onclick', "bb.pushScreen('views/relatedSubcategory.html', 'relatedView', {url :'" + $(item).attr('URL') + "' });");
			listItem.setAttribute("data-tunein-type", "no_image_item");
		}
		else if(itemType != null && itemType == "audio")
		{
			playing_image = $(item).attr('image');
			bitrate = $(item).attr('bitrate');
			guide_id = $(item).attr('guide_id');
			
			listItem.setAttribute('data-bb-type', 'item');
			listItem.setAttribute('data-bb-img', $(item).attr('image'));
			listItem.setAttribute('data-bb-title', $(item).attr('text'));

			if($(item).attr("text").toLowerCase().indexOf("not supported") == -1)
            {
				listItem.setAttribute('onclick', "bb.pushScreen('views/player.html', 'playerView',{stationId : '"+guide_id+"',playing_image : '"+playing_image+"' });");
			}
			
			listItem.innerHTML = $(item).attr('subtext');
			
		}
		else {
			if(!Utils.GeneralUtils.IsNullOrEmpty($(item).attr('text')))
            {
                listItem.setAttribute('class', 'sectionheader');
                listItem.innerHTML = listItem.innerHTML = $(item).attr('text');    
            }
		}
		
		return listItem;
	}
	
	return {
		Init: Init,
		doShowRelated : doShowRelated
	}
	
})();


