Namespace("BBUI_Helper");

BBUI_Helper.CreateGeneralItem = function(itemData) {

    var result = null;
    
    result = document.createElement("div");
    
    if(!Utils.GeneralUtils.IsNullOrEmpty(itemData.attr["data-bb-type"]) && 
        itemData.attr["data-bb-type"] === "header")
    {
        result.setAttribute("data-bb-type", "header");
        result.innerHTML = itemData.Title;
    }
    else
    {
        result.setAttribute("data-bb-type", "item");
    }
    
    result.setAttribute("data-id", itemData.ID);
    result.setAttribute("data-bb-title", itemData.Title);

    if (!Utils.GeneralUtils.IsNullOrUndefined(itemData.ImageUrl))
        result.setAttribute("data-bb-img", itemData.ImageUrl);

    if (!Utils.GeneralUtils.IsNullOrUndefined(itemData.Description))
        result.innerHTML = itemData.Description;

    if (!Utils.GeneralUtils.IsNullOrUndefined(itemData.Subtitle))
        result.setAttribute("data-bb-accent-text", itemData.Subtitle);

    if (itemData.attr != null) {
        for (var key in itemData.attr)
        {
            result.setAttribute(key, itemData.attr[key]);
        }
    }
    return result;
}

BBUI_Helper.CreateList = function(listItemSource) {
    var result = document.createElement("div");
    result.setAttribute("data-bb-type", "image-list");
    result.setAttribute("data-bb-header-justify", "left");
    for (var i = 0; i < listItemSource.length; i++) {
        item = BBUI_Helper.CreateGeneralItem(listItemSource[i]);
        if (item != null) {
            $(result).append(item);
        }
    }
    if (listItemSource.attr != null) {
        for (var key in listItemSource.attr)
        {
            result.setAttribute(key, listItemSource.attr[key]);
        }
    }
    return result;

}
