Namespace("Utils");

String.format = function() {
  var s = arguments[0];
  for (var i = 0; i < arguments.length - 1; i++) {       
    var reg = new RegExp("\\{" + i + "\\}", "gm");             
    s = s.replace(reg, arguments[i + 1]);
  }

  return s;
}

Utils.GeneralUtils = {
	
	GUID : function ()
	{
	    var S4 = function ()
	    {
	        return Math.floor(
	                Math.random() * 0x10000 /* 65536 */
	            ).toString(16);
	    };
	
	    return (
	            S4() + S4() + "-" +
	            S4() + "-" +
	            S4() + "-" +
	            S4() + "-" +
	            S4() + S4() + S4()
	        );
	},

	GenerateGuid : function() {
		return Utils.GeneralUtils.GUID();
	},
	
	GenerateUserID : function() {
		return "user" + Utils.GeneralUtils.GUID();
	},
	
	IsNullOrUndefined : function(obj) {
		return typeof(obj) == "undefined" || obj == null;
	},
	
	IsNullOrEmpty : function(str) {
		return typeof(str) == "undefined" || str == null || str == "";
	},
	
	GetTwoDigits : function(value) {
		if (value < 10) {
			return "0" + value; 
		}
		else {
			return value;
		}
	},
	
	FormatPlayDuration : function(total_seconds) {
		seconds = Math.floor(total_seconds % 60);
		minutes = Math.floor((total_seconds / 60) % 60);
		hours = Math.floor(total_seconds / (60 * 60));
		
		seconds = Utils.GeneralUtils.GetTwoDigits(seconds);
		minutes = Utils.GeneralUtils.GetTwoDigits(minutes);
		hours = Utils.GeneralUtils.GetTwoDigits(hours);
		
		return String.format("{0}:{1}:{2}", hours, minutes, seconds);
	}
}
