Namespace("Utils");

Utils.ParserUtil = (function(){

	//variables 
	var errMessage = '';
	var req = new XMLHttpRequest();
	var flag=false;
	var playindex=1; //keep track of the index of the current url in the playlist
	
	//variables for the Progress Bar on dowloading pls
	var states = {
		READY:0,
		DOWNLOADING:1,
		PREPARING:2
	};
	
//******************************************************************************************************************
/*
 * Download the playlist (pls), parse it and write it out to a div
 */

	function DownloadPls(url,callback) {
		try {
		    if (window.XMLHttpRequest)
		    { // Non-IE browsers
		      req = new XMLHttpRequest();
		      req.onreadystatechange = function(){

		      	if(req.readyState > 2)
				{
					if(req.getResponseHeader("Content-type").toLowerCase().indexOf("audio") != -1
						&& req.getResponseHeader("Content-type").toLowerCase().indexOf("pls") == -1)
					{
						req.abort();
						callback(url);
					}
				}
				
      			if (req.readyState == 4 && req.status == 200) {
	    		  var data = req.responseText;
	                
	    		  // if (!flag){//we want to make sure we only do the parsing once
	        //     	//do the parsing//
	    			  var playListArray = parsePlaylist(data);
	            	// now return the result in our callback
	            	if(playListArray.length > 0 && playListArray[0] != null && playListArray[0] != "")
	    			  callback(playListArray[0]);
	            	// }
	            	
				}
		      };
		      try
		      	{
		    	  req.open("GET", url, true);
		        } catch (e) {
		          //alert(e.getMessage());
		      }
		      req.send(null);
	
		    }
		} catch (ex) {
			//alert("Failed to get data from the server. Please check your data connection and try again. Error Code : 111 ");
			errMessage = errMessage + "\n downloadPls() : " + ex;
			//alert (errMessage);
			return null;
		}
	}

	function DownloadM3U(url, callback) {
		try {
		    if (window.XMLHttpRequest)
		    { // Non-IE browsers
		      req = new XMLHttpRequest();
		      req.onreadystatechange = function(){
		    	  if (req.readyState == 4 && req.status == 200) {
		    		  var data = req.responseText;
		                
		    			  var playListArray = parsePlaylistM3U(data);
		            	// now return the result in our callback
		    			  callback(playListArray[0]);
		            	
					} else {
						return null;
					}
		      };
		      try
		      	{
		    	  req.open("GET", url, true);
		        } catch (e) {
		          //alert(e.getMessage());
		      }
		      req.send(null);
	
		    }
		} catch (ex) {
			//alert("Failed to get data from the server. Please check your data connection and try again. Error Code : 111 ");
			errMessage = errMessage + "\n downloadM3U() : " + ex;
			//alert (errMessage);
			return null;
		}
	}

	function parsePlaylist(str) {
		
		
		var result = [];
		var playList = str.split("\n"); // array of streams/lines
		
		for(var i = playList.length-1; i >= 0; i--)
		{
			if(playList[i].trim().toLowerCase().indexOf("file") == "0" ) {
				result.push(playList[i].split("=")[1]);
			}
		}
		
		return result.reverse();	
		
	}

	function parsePlaylistM3U(str) {
		
		
		var playList = str.split("\n"); // array of streams
		
		for(var i = playList.length-1; i >= 0; i--)
		{
			if(playList[i].trim()[0] == "#" ) {
				playList.splice(i,1);
			}
		}

		return playList;
	}
        

	
	//In order to get some streams to play, characters need to appended to the end of the stream
	function FormatStream(streamUrl){
		streamUrl=streamUrl.trim();
		return streamUrl;
	}

	function somethingAfterPortNumber()
	{
		var last5Chars = streamUrl.slice(streamUrl.length-5,streamUrl.length);

		if(last5Chars.indexOf(":") == -1)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	return {
		DownloadPls : DownloadPls,
		DownloadM3U : DownloadM3U,
		FormatStream : FormatStream
	}

}());
